Subject: bug#70815: [PATCH] ; Enahnce python-tests.el to adapt different python interpreters

From: Mattias Engdegård <[email-masked]>
Date: Mon, 3 Jun 2024 16:02:30 +0200

2 juni 2024 kl. 15.20 skrev kobarity <[email-masked]>:

> The attached patch is my proposal.  I added PRED argument to
> `python-tests-get-shell-interpreter' to allow conditions to be
> specified when selecting an interpreter.  For now, I only provide a
> predicate that the major version of the interpreter is 3, but I think
> it would be easy to add.

That would work for me. (It could maybe be simplified a bit but that's not very important.)

> 1. Set EMACS_PYTHON_INTERPRETER environment variable to "python" and
>   run ERTs.  The expectation is that the 7 ERTs that previously
>   resulted in errors will be skipped.

With EMACS_PYTHON_INTERPRETER=python3 or unset

  SKIPPED  python-shell-completion-at-point-ipython
  SKIPPED  python-shell-completion-at-point-jedi-completer

With EMACS_PYTHON_INTERPRETER=python

  SKIPPED  python-completion-at-point-1
  SKIPPED  python-completion-at-point-2
  SKIPPED  python-completion-at-point-native-1
  SKIPPED  python-completion-at-point-native-2
  SKIPPED  python-completion-at-point-native-with-eldoc-1
  SKIPPED  python-completion-at-point-native-with-ffap-1
  SKIPPED  python-shell-completion-at-point-1
  SKIPPED  python-shell-completion-at-point-ipython
  SKIPPED  python-shell-completion-at-point-jedi-completer

> 2. Revert 9c7de10079 and run ERTs.  The expectation is that the 7 ERTs
>   that previously failed will succeed.

No, they still fail:

7 unexpected results:
   FAILED  python-completion-at-point-1
   FAILED  python-completion-at-point-2
   FAILED  python-completion-at-point-native-1
   FAILED  python-completion-at-point-native-2
   FAILED  python-completion-at-point-native-with-eldoc-1
   FAILED  python-completion-at-point-native-with-ffap-1
   FAILED  python-shell-completion-at-point-1

2 skipped results:
  SKIPPED  python-shell-completion-at-point-ipython
  SKIPPED  python-shell-completion-at-point-jedi-completer

> Apple seems to have removed Python 2 in 2022 MacOS 12.3.  Is your
> Python 2 installed with brew or something else? Or is it an old Apple
> one?

It's the standard setup of an older version of macOS (the hardware of that machine can't run 12.3).